


# Hands-On-System-Programming-with-Rust

<a href="https://www.packtpub.com/in/programming/practical-system-programming-for-rust-developers?utm_source=github&utm_medium=repository&utm_campaign=9781786461629"><img src="https://static.packt-cdn.com/products/9781800560963/cover/smaller" alt="Practical System Programming for Rust Developers" height="256px" align="right"></a>

This is the code repository for [Practical System Programming for Rust Developers](https://www.packtpub.com/in/programming/practical-system-programming-for-rust-developers?utm_source=github&utm_medium=repository&utm_campaign=9781786461629), published by Packt.

**Build fast and secure software for Linux/Unix systems with the help of practical examples**

## What is this book about?
This Rust book is designed to guide you through systems programming with Rust using practical examples and projects. You’ll explore various Rust features, along with useful techniques, which will help you to develop system tools, utilities, and more.


This book covers the following exciting features:
Gain a solid understanding of how system resources are managed
Use Rust confidently to control and operate a Linux or Unix system
Understand how to write a host of practical systems software tools and utilities
Delve into memory management with the memory layout of Rust programs
Discover the capabilities and features of the Rust Standard Library
Explore external crates to improve productivity for future Rust programming projects

If you feel this book is for you, get your [copy](https://www.amazon.com/dp/1800560966) today!

<a href="https://www.packtpub.com/?utm_source=github&utm_medium=banner&utm_campaign=GitHubBanner"><img src="https://raw.githubusercontent.com/PacktPublishing/GitHub/master/GitHub.png" 
alt="https://www.packtpub.com/" border="5" /></a>

## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
let num = 23;
let borrowed_num = &num; // immutable reference to num
```

**Following is what you need for this book:**
This book is for developers with basic knowledge of Rust but little to no knowledge or experience of systems programming. System programmers who want to consider Rust as an alternative to C or C++ will also find this book useful.

With the following software and hardware list you can run all code files present in the book (Chapter 1-12).
### Software and Hardware List
| No. | Software required | OS required |
| -------- | ------------------------------------ | ----------------------------------- |
| 1 | Rust | Windows, Mac OS X, and Linux (Any) |


We also provide a PDF file that has color images of the screenshots/diagrams used in this book. [Click here to download it](https://static.packt-cdn.com/downloads/9781800560963_ColorImages.pdf).

### Related products
* Creative Projects for Rust Programmers [[Packt]](https://www.packtpub.com/product/creative-projects-for-rust-programmers/9781789346220?utm_source=github&utm_medium=repository&utm_campaign=9781789346220) [[Amazon]](https://www.amazon.com/dp/B085P1MCXJ)

* Rust Programming Cookbook [[Packt]](https://www.packtpub.com/product/rust-programming-cookbook/9781789530667?utm_source=github&utm_medium=repository&utm_campaign=) [[Amazon]](https://www.amazon.com/dp/1789530660)

## Get to Know the Author
**Prabhu Eshwarla** has been shipping high-quality, business-critical software to large enterprises and running IT operations for over 25 years. He is also a passionate teacher of complex technologies.
Prabhu has worked with Hewlett Packard and has deep experience in software engineering, engineering management, and IT operations.
Prabhu is passionate about Rust and blockchain and specializes in distributed systems. He considers coding to be a creative craft, and an excellent tool to create new digital worlds (and experiences) sustained through rigorous software engineering.


### Download a free PDF

 <i>If you have already purchased a print or Kindle version of this book, you can get a DRM-free PDF version at no cost.<br>Simply click on the link to claim your free PDF.</i>
<p align="center"> <a href="https://packt.link/free-ebook/9781800560963">https://packt.link/free-ebook/9781800560963 </a> </p>